/*
*********************************************************************************************************
*
*	ģ : Ϣģ
*	ļ : bsp_msg.h
*	     : V1.0
*	˵     : ͷļ
*
*	Copyright (C), 2013-2014,  www.armfly.com
*
*********************************************************************************************************
*/

#ifndef __BSP_MSG_H
#define __BSP_MSG_H

#define MSG_FIFO_SIZE    40	   		/* Ϣ */

enum 
{
	MSG_NONE = 0,
	
	MSG_485_RX_RTU,		/* յRS485 MODBUS RTUݰ*/
	MSG_485_RX_NOT_RTU,	/* յRS485ݰCRCδ */
	
	MSG_CAN1_RX,		/* յCAN1ݰcan_netword.c  */
	MSG_CAN2_RX,		/* յCAN2ݰcan_netword.c  */
	
	MSG_WM8978_DMA_END,	/* DMA */
};

/* FIFOõ */
typedef struct
{
	uint16_t MsgCode;		/* Ϣ */
	uint32_t MsgParam;		/* Ϣ, Ҳָ루ǿת */
}MSG_T;

/* FIFOõ */
typedef struct
{
	MSG_T Buf[MSG_FIFO_SIZE];	/* Ϣ */
	uint8_t Read;					/* ָ1 */
	uint8_t Write;					/* дָ */
	uint8_t Read2;					/* ָ2 */
}MSG_FIFO_T;

/* ⲿõĺ */
void bsp_InitMsg(void);
void bsp_PutMsg(uint16_t _MsgCode, uint32_t _MsgParam);
uint8_t bsp_GetMsg(MSG_T *_pMsg);
uint8_t bsp_GetMsg2(MSG_T *_pMsg);
void bsp_ClearMsg(void);

#endif

/*****************************  www.armfly.com (END OF FILE) *********************************/
