/*
*********************************************************************************************************
*
*	ģ : ģ
*	ļ : main.c
*	     : V1.0
*	˵     : DMA2Dܲԡ
*              ʵĿģ
*                1. ѧϰDMA2Dʾɫ飬λͼAlphaϺͼƬϵȡ
*              ʵݣ
*                1. 1200msԶװʱLED2ÿ200msתһΡ
*                2. 1ͼʹDMA2Dˢɫ顣
*                3. 2ͼʾARGB8888λͼ
*                4. 3ͼʾRGB565λͼ
*                5. 4ͼλͼϡ
*                6. 5ͼAlpha͸200λͼʾ
*                7. 6ͼAlpha͸100λͼʾ
*              ע
*                1. ʵƼʹôSecureCRT鿴ӡϢ115200λ8żУλޣֹͣλ1
*                2. ؽ༭TABΪ4ĶļҪʾ롣
*
*	޸ļ¼ :
*		汾                    ˵
*		V1.0    2020-08-07   Eric2013     1. CMSIS汾 V5.7.0
*                                         2. HAL汾 V1.9.0
*                                         
*	Copyright (C), 2020-2030,  www.armfly.com
*
*********************************************************************************************************
*/	
#include "bsp.h"			 /* ײӲ */



/* ̷ */
#define EXAMPLE_NAME	"V7-DMA2Dܲԣʾɫ飬λͼAlphaϺͼƬϵȣ"
#define EXAMPLE_DATE	"2020-08-09"
#define DEMO_VER		"1.0"


static void PrintfHelp(void);
static void PrintfLogo(void);

/* DMA2Dɫ书 */
static void _DMA2D_Fill(void * pDst, 
	                    uint32_t xSize, 
                        uint32_t ySize, 
                        uint32_t OffLine, 
                        uint32_t ColorIndex, 
                        uint32_t PixelFormat);

/* ͨDMA2Dǰ㸴ָɫݵĿ */
static void _DMA2D_Copy(void * pSrc, 
	                    void * pDst, 
						uint32_t xSize, 
						uint32_t ySize, 
						uint32_t OffLineSrc, 
						uint32_t OffLineDst, 
						uint32_t PixelFormat);

/* ǰĿɫ */
static void _DMA2D_MixColorsBulk(uint32_t * pColorFG,  
	                             uint32_t OffLineSrcFG,
                                 uint32_t * pColorDst, 
                                 uint32_t OffLineDst,
							     uint32_t xSize, 
                                 uint32_t ySize, 
                                 uint8_t Intens);

/* ǰͱɫ */
static void _DMA2D_AlphaBlendingBulk(uint32_t * pColorFG,  
	                                 uint32_t OffLineSrcFG,
	                                 uint32_t * pColorBG,  
                                     uint32_t OffLineSrcBG,
                                     uint32_t * pColorDst, 
                                     uint32_t OffLineDst,
								     uint32_t xSize, 
                                     uint32_t ySize); 
/* ARGB8888ʽλͼʾ */
static void _DMA2D_DrawAlphaBitmap(void  * pDst, 
	                               void  * pSrc, 
								   uint32_t xSize, 
								   uint32_t ySize, 
								   uint32_t OffLineSrc, 
								   uint32_t OffLineDst, 
								   uint32_t PixelFormat);

/* ͼƬ */
extern const uint32_t _aclufei[128*128*4];
extern const uint32_t _acsuolong[128*128*4];
extern const uint16_t _achuoying[128*128*2];
extern const uint16_t _acmickey[128*128*2];
								   
extern const uint32_t _ac5[100*60*4];

/*
*********************************************************************************************************
*	  : main
*	˵: c
*	    : 
*	  ֵ: (账)
*********************************************************************************************************
*/
int main(void)
{
	uint16_t ucBright;	   	/* (0-255) */
    FONT_T tFont;		    /* һṹ */


	/*  */
	{
		tFont.FontCode = FC_ST_16;		/*  16 */
		tFont.FrontColor = CL_WHITE;	/* ɫ */
		tFont.BackColor = CL_BLUE;		/* ֱɫ */
		tFont.Space = 0;				/* ּ࣬λ =  */
	}	
	
	bsp_Init();		/* Ӳʼ */
	PrintfLogo();	/* ӡƺͰ汾Ϣ */
	PrintfHelp();	/* ӡʾ */

	/* ӳ200msٵ⣬˲ */
	bsp_DelayMS(200); 
	
	LCD_ClrScr(CL_BLUE);

	/* ʾϺٴ򿪱⣬Ϊȱʡ */
	bsp_DelayMS(100); 
	ucBright = BRIGHT_DEFAULT;
	LCD_SetBackLight(ucBright);
	
	/* 1ͼʹDMA2Dˢɫ ##############################################################*/
	LCD_DispStr(24, 2, "DMA2Dˢɫ", &tFont);
	_DMA2D_Fill((void *)(SDRAM_LCD_BUF1 + g_LcdWidth*20*2 + 24*2), /* ʾʼַ(24, 20) */  
                128,                                               /* ɫ鳤 */  
			    128,                                               /* ɫ */
			    g_LcdWidth-128,                                    /* ɫƫ */
			    CL_RED,                                            /* ɫɫ */
			    LTDC_PIXEL_FORMAT_RGB565);                         /* ɫɫʽ */                        

	/* 2ͼʾARGB8888λͼ ##############################################################*/
	LCD_DispStr(176, 2, "ˢARGB8888λͼ", &tFont);
    _DMA2D_DrawAlphaBitmap((void *)(SDRAM_LCD_BUF1 + g_LcdWidth*20*2 + 176*2), /* ʾʼַ(176, 20) */  
					   (void *)_ac5,                                   /* λͼַ */
					   100,                                                /* λͼ */
					   60,                                                /* λͼ */
					   0,                                                  /* λͼƫ */
					   g_LcdWidth-100,                                     /* Ŀƫ */
					   LTDC_PIXEL_FORMAT_RGB565);                          /* Ŀɫʽ */

	/* 3ͼʾRGB565λͼ ##############################################################*/
	LCD_DispStr(328, 2, "ˢRGB565λͼ", &tFont);
	_DMA2D_Copy((uint32_t *)_acmickey,                                        /* λͼַ */
			    (uint32_t *)(SDRAM_LCD_BUF1 + g_LcdWidth*20*2 + 328*2),       /* ʾʼַ(328, 20) */  
			    128,                                                          /* λͼ */
			    128,                                                          /* λͼ */
			    0,                                                            /* λͼƫ */
			    g_LcdWidth-128,                                               /* Ŀƫ */
				LTDC_PIXEL_FORMAT_RGB565);                                    /* Ŀɫʽ */


	/* 4ͼλͼ ##############################################################*/
	LCD_DispStr(24, 150, "λͼ", &tFont);						 
	_DMA2D_AlphaBlendingBulk((uint32_t *)_aclufei,                           /* ǰλͼַ */
						     0,                                              /* ǰƫ  */  
		                     (uint32_t *)_acsuolong,                         /* λͼַ  */  
							 0,                                              /* ƫ  */ 
						     (uint32_t *)(SDRAM_LCD_BUF1 +  g_LcdWidth*168*2 + 24*2), /* ʾʼַ(24, 168) */  
						     g_LcdWidth-128,                                 /* Ŀƫ */
						     128,                                            /* Ŀ */
						     128);                                           /* Ŀ */

	/* 5ͼAlpha͸200λͼʾ #######################################################*/
	LCD_DispStr(176, 150, "Alpha͸200", &tFont);
	_DMA2D_MixColorsBulk((uint32_t *)_achuoying,                                  /* λͼַ */
	                     0,                                                       /* λͼƫ */                     
					     (uint32_t *)(SDRAM_LCD_BUF1 + g_LcdWidth*168*2 + 176*2), /* ʾʼַ(176, 168) */
					     g_LcdWidth-128,                                          /* Ŀƫ */                                    
					     128,                                                     /* Ŀ */
					     128,                                                     /* Ŀ */          
					     200);                                                    /* λͼʾ͸200 */

	/* 6ͼAlpha͸100λͼʾ ####################################################*/
	LCD_DispStr(328, 150, "Alpha͸100", &tFont);
	_DMA2D_MixColorsBulk((uint32_t *)_achuoying,                                  /* λͼַ */
	                     0,                                                       /* λͼƫ */                     
					     (uint32_t *)(SDRAM_LCD_BUF1 + g_LcdWidth*168*2 + 328*2), /* ʾʼַ(328, 168) */
					     g_LcdWidth-128,                                          /* Ŀƫ */                                    
					     128,                                                     /* Ŀ */
					     128,                                                     /* Ŀ */          
					     100);                                                    /* λͼʾ͸200 */						 

	bsp_StartAutoTimer(0, 200); /* 1200msԶװĶʱʱ0 */
	
	while (1)
	{
       bsp_Idle();
         
		/* жʱ0Ƿʱ */
		if(bsp_CheckTimer(0))
		{
			/* ÿ200ms һ */  
			bsp_LedToggle(2);
		}
	}
}

/*
*********************************************************************************************************
*	  : _DMA2D_Fill
*	˵: DMA2Dɫ书
*	    : pDst          ɫĿĵַ
*             xSize         ɫXСÿ
*             ySize         ɫYС
*             OffLine       ǰͼƫ
*             ColorIndex    ɫɫֵ
*             PixelFormat   Ŀɫʽ
*	  ֵ: 
*********************************************************************************************************
*/
static void _DMA2D_Fill(void * pDst, 
	                    uint32_t xSize, 
                        uint32_t ySize, 
                        uint32_t OffLine, 
                        uint32_t ColorIndex, 
                        uint32_t PixelFormat) 
{
	
	/* DMA2DüĴ洢ģʽ, ģʽòǰͱ */  
	DMA2D->CR      = 0x00030000UL | (1 << 9);
	DMA2D->OCOLR   = ColorIndex;
	DMA2D->OMAR    = (uint32_t)pDst;
	DMA2D->OOR     = OffLine;
	DMA2D->OPFCCR  = PixelFormat;
	DMA2D->NLR     = (uint32_t)(xSize << 16) | (uint16_t)ySize;

	/*  */
	DMA2D->CR   |= DMA2D_CR_START;   

	/* ȴDMA2D */
	while (DMA2D->CR & DMA2D_CR_START) {} 
}

/*
*********************************************************************************************************
*	  : _DMA2D_Copy
*	˵: ͨDMA2Dǰ㸴ָɫݵĿ
*	    : pSrc          ɫԴַ
*             pDst          ɫĿĵַ
*             xSize         ĿXСÿ
*             ySize         ĿYС
*             OffLineSrc    ǰͼƫ
*             OffLineDst    ƫ
*             PixelFormat   Ŀɫʽ
*	  ֵ: 
*********************************************************************************************************
*/
static void _DMA2D_Copy(void * pSrc, 
	                    void * pDst, 
						uint32_t xSize, 
						uint32_t ySize, 
						uint32_t OffLineSrc, 
						uint32_t OffLineDst, 
						uint32_t PixelFormat) 
{

	/* DMA2Dô洢洢ģʽ, ģʽǰΪDMA2D */  
	DMA2D->CR      = 0x00000000UL | (1 << 9);
	DMA2D->FGMAR   = (uint32_t)pSrc;
	DMA2D->OMAR    = (uint32_t)pDst;
	DMA2D->FGOR    = OffLineSrc;
	DMA2D->OOR     = OffLineDst;
	
	/* ǰ򶼲õRGB565ɫʽ */
	DMA2D->FGPFCCR = LTDC_PIXEL_FORMAT_RGB565;
	DMA2D->OPFCCR  = LTDC_PIXEL_FORMAT_RGB565;
	
	DMA2D->NLR     = (uint32_t)(xSize << 16) | (uint16_t)ySize;

	/*  */
	DMA2D->CR   |= DMA2D_CR_START;   

	/* ȴDMA2D */
	while (DMA2D->CR & DMA2D_CR_START) {} 
}

/*
*********************************************************************************************************
*	  : _DMA2D_MixColorsBulk
*	˵: ǰĿɫ
*	    : pColorFG      ǰԴַ
*             OffLineSrcFG  ǰͼƫ
*             pColorDst     Ŀݵַ
*             OffLineDst    Ŀƫ
*             xSize         ĿXСÿ
*             ySize         ĿYС
*             Intens        ǰ͸ȣ255ʾȫ͸0ʾȫ͸
*	  ֵ: 
*********************************************************************************************************
*/
static void _DMA2D_MixColorsBulk(uint32_t * pColorFG,  
	                             uint32_t OffLineSrcFG,
                                 uint32_t * pColorDst, 
                                 uint32_t OffLineDst,
							     uint32_t xSize, 
                                 uint32_t ySize, 
                                 uint8_t Intens)
{
	/* DMA2Dô洢洢ģʽ, ģʽǰͱΪDMA2D룬֧ɫʽתɫ */  
	DMA2D->CR      = 0x00020000UL | (1 << 9);
	DMA2D->FGMAR   = (uint32_t)pColorFG;
	DMA2D->BGMAR   = (uint32_t)pColorDst;
	DMA2D->OMAR    = (uint32_t)pColorDst;
	DMA2D->FGOR    = OffLineSrcFG;
	DMA2D->BGOR    = OffLineDst;
	DMA2D->OOR     = OffLineDst;

	/* ǰ㣬õRGB565ʽ */
	DMA2D->FGPFCCR = LTDC_PIXEL_FORMAT_RGB565
				 | (1UL << 16)
				 | ((uint32_t)Intens << 24);
	DMA2D->BGPFCCR = LTDC_PIXEL_FORMAT_RGB565;
	DMA2D->OPFCCR  = LTDC_PIXEL_FORMAT_RGB565;

	DMA2D->NLR     = (uint32_t)(xSize << 16) | (uint16_t)ySize;
  
	/*  */
	DMA2D->CR   |= DMA2D_CR_START;   

	/* ȴDMA2D */
	while (DMA2D->CR & DMA2D_CR_START) {} 
}

/*
*********************************************************************************************************
*	  : _DMA2D_AlphaBlendingBulk
*	˵: ǰͱɫ
*	    : pColorFG      ǰԴݵַ
*             OffLineSrcFG  ǰԴƫ
*             pColorBG      Դݵַ
*             OffLineSrcBG  Դƫ
*             pColorDst     Ŀַ
*             OffLineDst    Ŀƫ
*             xSize         ĿXСÿ
*             ySize         ĿYС
*	  ֵ: 
*********************************************************************************************************
*/
static void _DMA2D_AlphaBlendingBulk(uint32_t * pColorFG,  
	                                 uint32_t OffLineSrcFG,
	                                 uint32_t * pColorBG,  
                                     uint32_t OffLineSrcBG,
                                     uint32_t * pColorDst, 
                                     uint32_t OffLineDst,
								     uint32_t xSize, 
                                     uint32_t ySize) 
{  
	/* DMA2Dô洢洢ģʽ, ģʽǰͱΪDMA2D룬֧ɫʽתɫ */  
	DMA2D->CR      = 0x00020000UL | (1 << 9);
	DMA2D->FGMAR   = (uint32_t)pColorFG;
	DMA2D->BGMAR   = (uint32_t)pColorBG;
	DMA2D->OMAR    = (uint32_t)pColorDst;
	DMA2D->FGOR    = OffLineSrcFG;
	DMA2D->BGOR    = OffLineSrcBG;
	DMA2D->OOR     = OffLineDst;

	/* ǰ㣬ARGB8888ʽRGB565ʽ */
	DMA2D->FGPFCCR = LTDC_PIXEL_FORMAT_ARGB8888;
	DMA2D->BGPFCCR = LTDC_PIXEL_FORMAT_ARGB8888;
	DMA2D->OPFCCR  = LTDC_PIXEL_FORMAT_RGB565;
	DMA2D->NLR     = (uint32_t)(xSize << 16) | (uint16_t)ySize;

	/*  */
	DMA2D->CR   |= DMA2D_CR_START;   

	/* ȴDMA2D */
	while (DMA2D->CR & DMA2D_CR_START) {} 
}

/*
*********************************************************************************************************
*	  : _DMA2D_DrawAlphaBitmap
*	˵: ARGB8888ʽλͼʾ
*	    : pDst        Ŀַ
*             pSrc        Դݵַλͼ׵ַ
*             xSize       ĿXСÿ
*             ySize       ĿYС
*             OffLineSrc  Դƫ
*             OffLineDst  Ŀƫ
*             PixelFormat Ŀɫʽ
*	  ֵ: 
*********************************************************************************************************
*/
static void _DMA2D_DrawAlphaBitmap(void  * pDst, 
	                               void  * pSrc, 
								   uint32_t xSize, 
								   uint32_t ySize, 
								   uint32_t OffLineSrc, 
								   uint32_t OffLineDst, 
								   uint32_t PixelFormat) 
{
	/* DMA2Dô洢洢ģʽ, ģʽǰͱΪDMA2D룬֧ɫʽתɫ */  
	DMA2D->CR      = 0x00020000UL | (1 << 9);
	DMA2D->FGMAR   = (uint32_t)pSrc;
	DMA2D->BGMAR   = (uint32_t)pDst;
	DMA2D->OMAR    = (uint32_t)pDst;
	DMA2D->FGOR    = OffLineSrc;
	DMA2D->BGOR    = OffLineDst;
	DMA2D->OOR     = OffLineDst;
	
	/* ǰɫʽLTDC_PIXEL_FORMAT_ARGB8888λͼɫʽɫʽ */
	DMA2D->FGPFCCR = LTDC_PIXEL_FORMAT_ARGB8888;
	DMA2D->BGPFCCR = PixelFormat;
	DMA2D->OPFCCR  = PixelFormat;
	DMA2D->NLR     = (uint32_t)(xSize << 16) | (uint16_t)ySize;

	/*  */
	DMA2D->CR   |= DMA2D_CR_START;   

	/* ȴDMA2D */
	while (DMA2D->CR & DMA2D_CR_START) {} 
}

/*
*********************************************************************************************************
*	  : PrintfHelp
*	˵: ӡʾ
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
static void PrintfHelp(void)
{
	printf("ʾ:\r\n");
	printf("1. 1ͼʹDMA2Dˢɫ\r\n");
	printf("2. 2ͼʾARGB8888λͼ\r\n");
	printf("3. 3ͼʾRGB565λͼ\r\n");
	printf("4. 4ͼλͼ\r\n");
	printf("5. 5ͼAlpha͸200\r\n");
	printf("6. 6ͼAlpha͸100\r\n");
}

/*
*********************************************************************************************************
*	  : PrintfLogo
*	˵: ӡƺ̷, ϴߺ󣬴PCĳնԹ۲
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void PrintfLogo(void)
{
	printf("*************************************************************\n\r");
	
	/* CPU ID */
	{
		uint32_t CPU_Sn0, CPU_Sn1, CPU_Sn2;
		
		CPU_Sn0 = *(__IO uint32_t*)(0x1FF1E800);
		CPU_Sn1 = *(__IO uint32_t*)(0x1FF1E800 + 4);
		CPU_Sn2 = *(__IO uint32_t*)(0x1FF1E800 + 8);

		printf("\r\nCPU : STM32H743XIH6, BGA240, Ƶ: %dMHz\r\n", SystemCoreClock / 1000000);
		printf("UID = %08X %08X %08X\n\r", CPU_Sn2, CPU_Sn1, CPU_Sn0);
	}

	printf("\n\r");
	printf("*************************************************************\n\r");
	printf("*    : %s\r\n", EXAMPLE_NAME);	/* ӡ */
	printf("* ̰汾   : %s\r\n", DEMO_VER);		/* ӡ̰汾 */
	printf("*    : %s\r\n", EXAMPLE_DATE);	/* ӡ */

	/* ӡSTHAL汾 */
	printf("* HAL汾  : V1.9.0 (STM32H7xx HAL Driver)\r\n");
	printf("* \r\n");	/* ӡһпո */
	printf("* QQ    : 1295744630 \r\n");
	printf("*   : armfly\r\n");
	printf("* Email : armfly@qq.com \r\n");
	printf("* ΢Źں: armfly_com \r\n");
	printf("* Ա: armfly.taobao.com\r\n");
	printf("* Copyright www.armfly.com \r\n");
	printf("*************************************************************\n\r");
}

/*****************************  www.armfly.com (END OF FILE) *********************************/
